'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('../package.json'),
    version = _require.version;

var $w = typeof wx !== 'undefined' && wx;

var DEFAULT_TITLE = '更新提示';
var DEFAULT_CONTENT = '新版本已经准备好，是否重启应用？';

var ERROR_MESSAGE = '非微信环境';

var assert = function assert(value, message) {
  value = typeof value === 'boolean' ? value : false;
  if (!value) {
    throw new Error(message);
  }
};
var checkValidate = function checkValidate(ctx) {
  assert(typeof ctx.manager !== 'undefined', ERROR_MESSAGE);
};

var Manager = function () {
  function Manager() {
    _classCallCheck(this, Manager);

    this.version = version;
    assert(typeof $w !== 'undefined', ERROR_MESSAGE);
    this.setTitle().setContent();
    this.manager = $w.getUpdateManager();
    checkValidate(this);
  }

  _createClass(Manager, [{
    key: 'setTitle',
    value: function setTitle() {
      var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_TITLE;

      this.title = title;
      return this;
    }
  }, {
    key: 'setContent',
    value: function setContent() {
      var content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_CONTENT;

      this.content = content;
      return this;
    }
  }, {
    key: 'onMessage',
    value: function onMessage(cb) {
      checkValidate(this);
      typeof cb === 'function' && this.manager.onCheckForUpdate(cb);
      return this;
    }
  }, {
    key: 'onReady',
    value: function onReady(cb) {
      var _this = this;

      checkValidate(this);
      if (typeof cb === 'function') {
        this.manager.onUpdateReady(cb);
      } else {
        var title = this.title,
            content = this.content;

        this.manager.onUpdateReady(function () {
          $w.showModal({
            title: title,
            content: content,
            success: function success(res) {
              if (res.confirm) {
                $w.clearStorageSync();
                _this.manager.applyUpdate();
              }
            }
          });
        });
      }
      return this;
    }
  }, {
    key: 'onFail',
    value: function onFail(cb) {
      if (typeof this.manager === 'undefined') {
        typeof cb === 'function' && cb(ERROR_MESSAGE);
      } else {
        typeof cb === 'function' && this.manager.onUpdateFailed(cb);
      }
      return this;
    }
  }]);

  return Manager;
}();

module.exports = new Manager();
